DefinitionBlock ("DSDT.aml", "DSDT", 1, "DELL", "dt_ex", 0x00001000)
{
    Method (DBIN, 0, NotSerialized)
    {
        Noop
    }
    Scope (\)
    {
        Device (_SB.VBTN)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Name (_PRW, Package (0x02)
            {
                One, 
                0x04
            })
        }
        OperationRegion (SSTS, SystemIO, 0x0828, One)
        Field (SSTS, ByteAcc, NoLock, WriteAsZeros)
        {
            TSTS,   1
        }
        OperationRegion (SACT, SystemIO, 0x082A, One)
        Field (SACT, ByteAcc, NoLock, WriteAsZeros)
        {
                ,   2, 
            TPOL,   1
        }
    }
    Scope (_GPE)
    {
        Method (_L00, 0, NotSerialized)
        {
            Store (Zero, TPOL)
            Store (One, TSTS)
            Notify (\_SB.VBTN, 0x02)
        }
    }
    Scope (_SB)
    {
        Method (_INI, 0, NotSerialized)
        {
            If (CondRefOf (_OSI, Local0))
            {
                If (_OSI ("Windows 2001"))
                {
                    Store (0x04, MSOS)
                }
            }
        }
    }
    Scope (\)
    {
        Name (MSOS, Zero)
        Mutex (MTX, 0x01)
        Method (CMRD, 1, NotSerialized)
        {
            Acquire (SMIM, 0xFFFF)
            Store (Arg0, Local0)
            And (Local0, 0x7F, Local0)
            Store (Local0, SMID)
            Store (0x84, SMIC)
            Store (0x85, SMIC)
            Store (SMID, Local0)
            Release (SMIM)
            Return (Local0)
        }
        Method (CMWR, 2, NotSerialized)
        {
            Acquire (SMIM, 0xFFFF)
            Store (Arg0, Local0)
            Or (Local0, 0x80, Local0)
            Store (Local0, SMID)
            Store (0x84, SMIC)
            Store (Arg1, SMID)
            Store (0x85, SMIC)
            Release (SMIM)
        }
        Method (GCKB, 0, NotSerialized)
        {
            Return (And (0x20, CMRD (0x26)))
        }
        Method (GCMS, 0, NotSerialized)
        {
            Return (And (0x40, CMRD (0x6F)))
        }
        Method (GCON, 0, NotSerialized)
        {
            Return (And (0x04, CMRD (0x55)))
        }
        Method (GCUC, 0, NotSerialized)
        {
            And (One, CMRD (0x22), Local0)
            Return (XOr (One, Local0))
        }
        Method (GCS1, 0, NotSerialized)
        {
            Return (And (0x03, CMRD (0x25)))
        }
        Method (GCS2, 0, NotSerialized)
        {
            Return (And (0x0C, CMRD (0x25)))
        }
        Method (GCFD, 0, NotSerialized)
        {
            Return (And (0x18, CMRD (0x55)))
        }
        Method (GCPP, 0, NotSerialized)
        {
            Return (And (0x70, CMRD (0x23)))
        }
        Method (GCTP, 0, NotSerialized)
        {
            Return (And (0x40, CMRD (0x22)))
        }
        Method (GCNC, 0, NotSerialized)
        {
            Return (And (0x03, CMRD (0x59)))
        }
        Method (HACK, 0, NotSerialized)
        {
            If (LEqual (MSOS, 0x04))
            {
                Store (CMRD (0x6F), Local0)
                Or (Local0, 0x04, Local0)
                CMWR (0x6F, Local0)
                Return (One)
            }
            Else
            {
                Store (CMRD (0x6F), Local0)
                And (Local0, 0xFB, Local0)
                CMWR (0x6F, Local0)
            }
            Add (SizeOf (_OS), One, Local0)
            Store (Local0, Local1)
            Name (BUF0, Buffer (Local0) {})
            Name (BUF1, Buffer (Local0) {})
            Name (OSNT, One)
            Name (OS98, One)
            Store (_OS, BUF0)
            Store ("Microsoft Windows NT", BUF1)
            While (Local0)
            {
                Decrement (Local0)
                If (LEqual (DerefOf (Index (BUF0, Local0)), DerefOf (Index (BUF1, 
                    Local0)))) {}
                Else
                {
                    Store (Zero, OSNT)
                }
            }
            If (OSNT)
            {
                Store (0x03, MSOS)
                Return (One)
            }
            Else
            {
                Store ("Microsoft Windows", BUF1)
                While (Local1)
                {
                    Decrement (Local1)
                    If (LEqual (DerefOf (Index (BUF0, Local1)), DerefOf (Index (BUF1, 
                        Local1)))) {}
                    Else
                    {
                        Store (Zero, OS98)
                    }
                }
                If (OS98)
                {
                    Store (One, MSOS)
                    Return (Zero)
                }
                Else
                {
                    Store (0x02, MSOS)
                    Return (Zero)
                }
            }
        }
        Method (ISLI, 0, NotSerialized)
        {
            If (CondRefOf (_OSI, Local0))
            {
                If (_OSI ("Linux"))
                {
                    Return (One)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Else
            {
                Return (Zero)
            }
        }
    }
    Scope (_SB)
    {
    }
    OperationRegion (CMS, SystemIO, 0x70, 0x02)
    Field (CMS, ByteAcc, NoLock, Preserve)
    {
        CMSI,   8, 
        CMSD,   8
    }
    OperationRegion (SMIR, SystemIO, 0xB2, 0x02)
    Field (SMIR, ByteAcc, NoLock, Preserve)
    {
        SMIC,   8, 
        SMID,   8
    }
    OperationRegion (STON, SystemIO, 0x84, One)
    Field (STON, ByteAcc, NoLock, Preserve)
    {
        MGIC,   8
    }
    OperationRegion (SIO, SystemIO, 0x2E, 0x02)
    Field (SIO, ByteAcc, NoLock, Preserve)
    {
        SIOI,   8, 
        SIOD,   8
    }
    OperationRegion (PM1R, SystemIO, 0x0800, 0x04)
    Field (PM1R, ByteAcc, NoLock, Preserve)
    {
        PMS1,   8, 
        PMS2,   8, 
        PME1,   8, 
        PME2,   8
    }
    OperationRegion (GPST, SystemIO, 0x0820, One)
    Field (GPST, ByteAcc, NoLock, Preserve)
    {
        GST0,   8
    }
    OperationRegion (GLBC, SystemIO, 0x0828, 0x06)
    Field (GLBC, ByteAcc, NoLock, Preserve)
    {
        THRP,   8, 
        GLBT,   8, 
        EOS,    8, 
        LIDP,   8, 
        THME,   8, 
        RIEN,   8
    }
    OperationRegion (GPEC, SystemIO, 0x0842, One)
    Field (GPEC, ByteAcc, NoLock, Preserve)
    {
        THPL,   1, 
        SWGP,   1, 
        Offset (0x01)
    }
    OperationRegion (PMES, SystemIO, 0x0C00, One)
    Field (PMES, ByteAcc, NoLock, Preserve)
    {
        GSTS,   8
    }
    Mutex (SMIM, 0x01)
    Method (SMI, 2, NotSerialized)
    {
        Acquire (SMIM, 0xFFFF)
        Store (Arg1, SMID)
        Store (Arg0, SMIC)
        Store (MGIC, Local0)
        Store (SMID, Local1)
        Release (SMIM)
        Return (Local1)
    }
    Method (SMI1, 1, NotSerialized)
    {
        Acquire (SMIM, 0xFFFF)
        Store (Arg0, SMIC)
        Store (MGIC, Local0)
        Store (SMID, Local0)
        Release (SMIM)
        Return (Local0)
    }
    Method (SMI2, 1, NotSerialized)
    {
        Acquire (SMIM, 0xFFFF)
        Store (Arg0, SMIC)
        Store (MGIC, Local0)
        Store (SMIC, Local1)
        Store (SMID, Local0)
        ShiftLeft (Local0, 0x08, Local0)
        Add (Local1, Local0, Local0)
        Release (SMIM)
        Return (Local0)
    }
    Method (SMI4, 1, NotSerialized)
    {
        Add (Arg0, One, Local0)
        Store (SMI2 (Arg0), Local2)
        Store (SMI2 (Local0), Local1)
        ShiftLeft (Local1, 0x10, Local1)
        Add (Local1, Local2, Local0)
        Return (Local0)
    }
    Method (GTMR, 0, NotSerialized)
    {
        Return (SMI4 (0x78))
    }
    Method (GTML, 0, NotSerialized)
    {
        Return (SMI4 (0x74))
    }
    Method (GTMH, 0, NotSerialized)
    {
        Return (SMI4 (0x76))
    }
    Method (GTOM, 0, NotSerialized)
    {
        Return (SMI4 (0x81))
    }
    Method (GUSB, 0, NotSerialized)
    {
        If (ISLI ())
        {
            Return (Zero)
        }
        Else
        {
            Return (SMI2 (0xBA))
        }
    }
    Method (GTPM, 0, NotSerialized)
    {
        Return (SMI (0x96, Zero))
    }
    Scope (_PR)
    {
        Processor (CPU0, 0x01, 0x00000810, 0x06)
        {
        }
        Processor (CPU1, 0x02, 0x00000000, 0x00)
        {
        }
        Processor (CPU2, 0x03, 0x00000000, 0x00)
        {
        }
        Processor (CPU3, 0x04, 0x00000000, 0x00)
        {
        }
    }
    Scope (\)
    {
        Name (SSTX, Zero)
        Method (_PTS, 1, NotSerialized)
        {
            PSKM (Arg0)
        }
    }
    Method (_GPE._L1A, 0, NotSerialized)
    {
        XOr (LIDP, 0x04, LIDP)
        Or (PME2, One, PME2)
        Notify (\_SB.PCI0.PCI5, 0x02)
    }
    Method (_GPE._L1B, 0, NotSerialized)
    {
        XOr (LIDP, 0x08, LIDP)
        Or (PME2, One, PME2)
        Notify (\_SB.PCI0.PCI1, 0x02)
    }
    Method (_GPE._L08, 0, NotSerialized)
    {
        GPKM ()
        If (Not (LEqual (SSTX, One)))
        {
            Notify (\_SB.VBTN, 0x02)
        }
        Notify (\_SB.PCI0.ISA.KBD, 0x02)
    }
    /* Added by Herv */
    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */ 0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44,
                    /* 0008 */ 0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }
                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }
        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }
    /* End DTGP insertion */
    Method (_WAK, 1, NotSerialized)
    {
        If (LEqual (Arg0, 0x04))
        {
            GUSB ()
        }
        Else
        {
            If (LEqual (Arg0, 0x03))
            {
                If (And (0x20, CMRD (0x49)))
                {
                    GUSB ()
                }
            }
        }
        CMWR (0x49, And (0xDF, CMRD (0x49)))
        If (Or (And (PMS2, One), Or (And (LNot (HACK ()), 
            And (GLBT, 0x11)), And (LNot (HACK ()), And (THRP, 0x18
            )))))
        {
            Notify (\_SB.VBTN, 0x02)
        }
        Return (Zero)
    }
    Scope (_SI)
    {
        Method (_SST, 1, NotSerialized)
        {
            Store (Arg0, SSTX)
            If (LEqual (Arg0, 0x03))
            {
                And (LED2, 0xFD, LED2)
            }
            If (LEqual (Arg0, One))
            {
                Or (LED2, 0x02, LED2)
            }
        }
    }
    Scope (_SB)
    {
        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A03"))
            Name (_UID, 0x00)
            Name (_ADR, Zero)
            Name (_PRW, Package (0x02)
            {
                0x0D, 
                0x05
            })
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
            Device (PCI4)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x001E0000, Local0)
                    Return (Local0)
                }
                Name (_UID, 0x07)
                Name (_PRW, Package (0x02)
                {
                    0x0B, 
                    0x05
                })
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API4, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC4, Local0)
                    }
                    Return (Local0)
                }
            }
            Device (PCI2)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x001C0000, Local0)
                    Return (Local0)
                }
                Name (_UID, 0x16)
                OperationRegion (RSTS, PCI_Config, 0x60, 0x04)
                Field (RSTS, ByteAcc, NoLock, Preserve)
                {
                    PID0,   8, 
                    PID1,   8, 
                    PMXS,   8, 
                    PNUS,   8
                }
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API2, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC2, Local0)
                    }
                    Return (Local0)
                }
            }
            Device (PCI3)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x001C0001, Local0)
                    Return (Local0)
                }
                Name (_UID, 0x18)
                Name (_PRW, Package (0x02)
                {
                    0x1E, 
                    0x05
                })
                OperationRegion (RSTS, PCI_Config, 0x60, 0x04)
                Field (RSTS, ByteAcc, NoLock, Preserve)
                {
                    PID0,   8, 
                    PID1,   8, 
                    PMXS,   8, 
                    PNUS,   8
                }
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API3, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC3, Local0)
                    }
                    Return (Local0)
                }
            }
            Device (PCI1)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x00010000, Local0)
                    Return (Local0)
                }
                Device (GFX0)
                {
                    Name (_ADR, Zero)
                    Method (_DSM, 4, NotSerialized)
                    {
                        Store (Package (0x1C)
                            {
                                "AAPL,slot-name", 
                                "PCIe x16", 
                                "@0,compatible", 
                                Buffer (0x0B)
                                {
                                    "NVDA,NVMac"
                                }, 
                                "@0,display-cfg", 
                                Buffer (0x04)
                                {
                                     0x03, 0x01, 0x00, 0x00
                                }, 
                                "@0,device-type", 
                                Buffer (0x08)
                                {
                                    "display"
                                }, 
                                "@0,name", 
                                Buffer (0x0F)
                                {
                                    "NVDA,Display-A"
                                }, 
                                "@1,compatible", 
                                Buffer (0x0B)
                                {
                                    "NVDA,NVMac"
                                }, 
                                "@1,display-cfg", 
                                Buffer (0x04)
                                {
                                     0xFF, 0xFF, 0x00, 0x01
                                }, 
                                "@1,device-type", 
                                Buffer (0x08)
                                {
                                    "display"
                                }, 
                                "@1,name", 
                                Buffer (0x0F)
                                {
                                    "NVDA,Display-B"
                                }, 
                                "NVCAP", 
                                Buffer (0x14)
                                {
                                    /* 0000 */   0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
                                    /* 0008 */   0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0A,
                                    /* 0010 */   0x00, 0x00, 0x00, 0x00
                                }, 
                                "VRAM,totalsize", 
                                Buffer (0x04)
                                {
                                     0x00, 0x00, 0x00, 0x20 // 512Mo VRAM
                                }, 
                                "device-type", 
                                Buffer (0x0C)
                                {
                                    "NVDA,Parent"
                                }, 
                                "model", 
                                Buffer (0x15)
                                {
                                    "nVidia Quadro FX3700"
                                }, 
                                "hda-gfx", 
                                Buffer (0x0A)
                                {
                                    "onboard-1"
                                }
                            }, Local0)
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                }
                Name (_UID, 0x19)
                Name (_PRW, Package (0x02)
                {
                    0x1B, 
                    0x05
                })
                OperationRegion (RSTS, PCI_Config, 0xC0, 0x04)
                Field (RSTS, ByteAcc, NoLock, Preserve)
                {
                    PID0,   8, 
                    PID1,   8, 
                    PMXS,   8, 
                    PNUS,   8
                }
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API1, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC1, Local0)
                    }
                    Return (Local0)
                }
            }
            Device (PCI5)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x001C0004, Local0)
                    Return (Local0)
                }
                Name (_UID, 0x20)
                OperationRegion (RSTS, PCI_Config, 0x60, 0x04)
                Field (RSTS, ByteAcc, NoLock, Preserve)
                {
                    PID0,   8, 
                    PID1,   8, 
                    PMXS,   8, 
                    PNUS,   8
                }
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API5, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC5, Local0)
                    }
                    Return (Local0)
                }
            }
            Device (PCI6)
            {
                Method (_S1D, 0, NotSerialized)
                {
                    Return (One)
                }
                Method (_S2D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_S4D, 0, NotSerialized)
                {
                    If (HACK ())
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        Return (0x02)
                    }
                }
                Method (_ADR, 0, NotSerialized)
                {
                    Store (0x001C0005, Local0)
                    Return (Local0)
                }
                Name (_UID, 0x21)
                Name (_PRW, Package (0x02)
                {
                    0x1E, 
                    0x05
                })
                OperationRegion (RSTS, PCI_Config, 0x60, 0x04)
                Field (RSTS, ByteAcc, NoLock, Preserve)
                {
                    PID0,   8, 
                    PID1,   8, 
                    PMXS,   8, 
                    PNUS,   8
                }
                Method (_PRT, 0, NotSerialized)
                {
                    Store (API6, Local0)
                    If (LNot (PICF))
                    {
                        Store (PIC6, Local0)
                    }
                    Return (Local0)
                }
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Name (PIC0, Package (0x18)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x02, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                LNKE, 
                Zero
            }
        })
        Name (API0, Package (0x18)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x02, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                Zero, 
                0x14
            }
        })
    }
    Scope (_SB.PCI0.PCI1)
    {
        Name (PIC1, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (API1, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
    }
    Scope (_SB.PCI0.PCI2)
    {
        Name (PIC2, Package (0x08)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (API2, Package (0x08)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
    }
    Scope (_SB.PCI0.PCI3)
    {
        Name (PIC3, Package (0x00) {})
        Name (API3, Package (0x00) {})
    }
    Scope (_SB.PCI0.PCI4)
    {
        Name (PIC4, Package (0x10)
        {
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (API4, Package (0x10)
        {
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
    }
    Scope (_SB.PCI0.PCI5)
    {
        Name (PIC5, Package (0x00) {})
        Name (API5, Package (0x00) {})
    }
    Scope (_SB.PCI0.PCI6)
    {
        Name (PIC6, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (API6, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
    }
    Scope (\)
    {
        Method (_GPE._L03, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (THRP, 0x08, THRP)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB0, 0x02)
        }
        Method (_GPE._L04, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (THRP, 0x10, THRP)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB1, 0x02)
        }
        Method (_GPE._L0C, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (GLBT, 0x10, GLBT)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB2, 0x02)
        }
        Method (_GPE._L0E, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (GLBT, 0x40, GLBT)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB3, 0x02)
        }
        Method (_GPE._L05, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (THRP, 0x20, THRP)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB4, 0x02)
        }
        Method (_GPE._L20, 0, NotSerialized)
        {
            If (Not (LEqual (SSTX, One)))
            {
                Notify (\_SB.VBTN, 0x02)
            }
            Sleep (0x14)
            XOr (THRP, 0x20, THRP)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.USB5, 0x02)
        }
        Method (_GPE._L0D, 0, NotSerialized)
        {
            Sleep (0x14)
            XOr (GLBT, 0x20, GLBT)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0, 0x02)
        }
        Method (_GPE._L0B, 0, NotSerialized)
        {
            XOr (GLBT, 0x08, GLBT)
            Or (PME2, One, PME2)
            Notify (\_SB.PCI0.PCI4, 0x02)
        }
    }
    Scope (_SB.PCI0)
    {
        Device (ISA)
        {
            Name (_ADR, 0x001F0000)
            Name (_UID, 0x0A)
            OperationRegion (P40C, PCI_Config, 0x60, 0x04)
            OperationRegion (P41C, PCI_Config, 0x68, 0x04)
            Device (MBIO)
            {
                Name (_HID, EisaId ("PNP0C01"))
                Name (_UID, 0x0B)
                Method (_CRS, 0, NotSerialized)
                {
                    Name (MIO1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x01,               // Alignment
                            0x0B,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0800,             // Range Minimum
                            0x0800,             // Range Maximum
                            0x01,               // Alignment
                            0x60,               // Length
                            )
                        IO (Decode16,
                            0x0C00,             // Range Minimum
                            0x0C00,             // Range Maximum
                            0x01,               // Alignment
                            0x80,               // Length
                            )
                        IO (Decode16,
                            0x0860,             // Range Minimum
                            0x0860,             // Range Maximum
                            0x01,               // Alignment
                            0xA0,               // Length
                            )
                    })
                    Name (MIO2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x01,               // Alignment
                            0x0B,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0800,             // Range Minimum
                            0x0800,             // Range Maximum
                            0x01,               // Alignment
                            0x60,               // Length
                            )
                        IO (Decode16,
                            0x0C00,             // Range Minimum
                            0x0C00,             // Range Maximum
                            0x01,               // Alignment
                            0x80,               // Length
                            )
                        IO (Decode16,
                            0x0860,             // Range Minimum
                            0x0860,             // Range Maximum
                            0x01,               // Alignment
                            0xA0,               // Length
                            )
                    })
                    If (Or (GCKB (), GCMS ()))
                    {
                        Return (MIO1)
                    }
                    Else
                    {
                        Return (MIO2)
                    }
                }
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Device (USB0)
        {
            Name (_ADR, 0x001D0000)
            Name (_UID, 0x05)
            Name (_PRW, Package (0x02)
            {
                0x03, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
                GUSB ()
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
        Device (USB1)
        {
            Name (_ADR, 0x001D0001)
            Name (_UID, 0x06)
            Name (_PRW, Package (0x02)
            {
                0x04, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
        Device (USB2)
        {
            Name (_ADR, 0x001D0002)
            Name (_UID, 0x14)
            Name (_PRW, Package (0x02)
            {
                0x0C, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
        Device (USB3)
        {
            Name (_ADR, 0x001A0000)
            Name (_UID, 0x15)
            Name (_PRW, Package (0x02)
            {
                0x0E, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
        Device (USB4)
        {
            Name (_ADR, 0x001A0001)
            Name (_UID, 0x16)
            Name (_PRW, Package (0x02)
            {
                0x05, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
        Device (USB5)
        {
            Name (_ADR, 0x001A0002)
            Name (_UID, 0x1A)
            Name (_PRW, Package (0x02)
            {
                0x20, 
                0x03
            })
            OperationRegion (UPC1, PCI_Config, 0xC1, One)
            Field (UPC1, ByteAcc, NoLock, Preserve)
            {
                LEGK,   8
            }
            Method (_INI, 0, NotSerialized)
            {
                If (HACK ()) {}
                Else
                {
                    Store (LEGK, Local0)
                    And (Local0, 0x60, Local0)
                    Or (Local0, 0x20, Local0)
                    Store (Local0, LEGK)
                }
            }
            Method (_STA, 0, NotSerialized)
            {
                If (GCUC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_S1D, 0, NotSerialized)
            {
                Return (One)
            }
            Method (_S2D, 0, NotSerialized)
            {
                If (HACK ())
                {
                    Return (0x03)
                }
                Else
                {
                    Return (0x02)
                }
            }
        }
    }
    Scope (\)
    {
        Name (PICF, Zero)
        Method (_PIC, 1, NotSerialized)
        {
            Store (Arg0, PICF)
        }
    }
    Scope (_SB.PCI0)
    {
        Method (_PRT, 0, NotSerialized)
        {
            Store (API0, Local0)
            If (LNot (PICF))
            {
                Store (PIC0, Local0)
            }
            Return (Local0)
        }
        Method (_CRS, 0, NotSerialized)
        {
            OperationRegion (ORMF, SystemMemory, 0x000FFF6C, 0x04)
            Field (ORMF, WordAcc, NoLock, Preserve)
            {
                ORGP,   16, 
                ORND,   16
            }
            Name (MEMP, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x00FF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0100,             // Length
                    ,, )
                IO (Decode16,
                    0x0CF8,             // Range Minimum
                    0x0CF8,             // Range Maximum
                    0x01,               // Alignment
                    0x08,               // Length
                    )
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0CF7,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0CF8,             // Length
                    ,, , TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0D00,             // Range Minimum
                    0xFFFF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0xF300,             // Length
                    ,, , TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000A0000,         // Range Minimum
                    0x000BFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C8000,         // Range Minimum
                    0x000DFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00018000,         // Length
                    ,, _Y00, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000E0000,         // Range Minimum
                    0x000FFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, _Y01, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xF0000000,         // Range Minimum
                    0xFEC00000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x0ec00001,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinNotFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0xDFFFFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, _Y02, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinNotFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0xEFFFFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinNotFixed, MaxNotFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFF980800,         // Range Minimum
                    0xFF980BFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000400,         // Length
                    ,, _Y03, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinNotFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFF97C000,         // Range Minimum
                    0xFF97FFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, NonCacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0xFED20000,         // Range Minimum
                    0xFED9FFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00080000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
            })
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y00._MIN, PMIN)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y00._MAX, PMAX)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y00._LEN, PLEN)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y01._MIN, BMIN)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y01._LEN, BLEN)
            ShiftLeft (ORGP, 0x04, BMIN)
            Subtract (0x00100000, BMIN, BLEN)
            Store (0x000C0000, PMIN)
            Subtract (BMIN, One, PMAX)
            Subtract (BMIN, PMIN, PLEN)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y02._MIN, MEMM)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y02._LEN, MEML)
            Store (GTOM (), MEMM)
            Subtract (0xDFFFFFFF, MEMM, MEML)
            Increment (MEML)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y03._MIN, UMIN)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y03._MAX, UMAX)
            CreateDWordField (MEMP, \_SB.PCI0._CRS._Y03._LEN, ULEN)
            If (GCUC ()) {}
            Else
            {
                Store (Zero, UMIN)
                Store (Zero, UMAX)
                Store (Zero, ULEN)
            }
            Return (MEMP)
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (DMA)
        {
            Name (_HID, EisaId ("PNP0200"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (DMAB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0080,             // Range Minimum
                        0x0080,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    IO (Decode16,
                        0x0000,             // Range Minimum
                        0x0000,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    IO (Decode16,
                        0x00C0,             // Range Minimum
                        0x00C0,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    DMA (Compatibility, NotBusMaster, Transfer16, )
                        {4}
                })
                Return (DMAB)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (FPU)
        {
            Name (_HID, EisaId ("PNP0C04"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (FPUB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x00F0,             // Range Minimum
                        0x00F0,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IRQNoFlags ()
                        {13}
                })
                Return (FPUB)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (PIC)
        {
            Name (_HID, EisaId ("PNP0000"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (PICB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0020,             // Range Minimum
                        0x0020,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    IO (Decode16,
                        0x00A0,             // Range Minimum
                        0x00A0,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    IO (Decode16,
                        0x04D0,             // Range Minimum
                        0x04D0,             // Range Maximum
                        0x01,               // Alignment
                        0x02,               // Length
                        )
                    IRQNoFlags ()
                        {2}
                })
                Return (PICB)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (SPK)
        {
            Name (_HID, EisaId ("PNP0800"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (SPKB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0061,             // Range Minimum
                        0x0061,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                })
                Return (SPKB)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (RTC)
        {
            Name (_HID, EisaId ("PNP0B00"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (RTCB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0070,             // Range Minimum
                        0x0070,             // Range Maximum
                        0x01,               // Alignment
                        0x10,               // Length
                        )
                    IRQNoFlags ()
                        {8}
                })
                Return (RTCB)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (TMR)
        {
            Name (_HID, EisaId ("PNP0100"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (TMRB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0040,             // Range Minimum
                        0x0040,             // Range Maximum
                        0x01,               // Alignment
                        0x20,               // Length
                        )
                    IRQNoFlags ()
                        {0}
                })
                Return (TMRB)
            }
        }
    }
    Scope (_SB)
    {
        Field (PCI0.ISA.P40C, ByteAcc, NoLock, Preserve)
        {
            PRQ0,   8, 
            PRQ1,   8, 
            PRQ2,   8, 
            PRQ3,   8
        }
        Field (PCI0.ISA.P41C, ByteAcc, NoLock, Preserve)
        {
            PRQ4,   8, 
            PRQ5,   8, 
            PRQ6,   8, 
            PRQ7,   8
        }
        Device (LNKA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0C)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ0, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ0, 0x80, PRQ0)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR0, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR0, One, IQR)
                Store (PRQ0, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR0)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ0)
            }
        }
        Device (LNKB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0D)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ1, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ1, 0x80, PRQ1)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR1, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR1, One, IQR)
                Store (PRQ1, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR1)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ1)
            }
        }
        Device (LNKC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0E)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ2, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ2, 0x80, PRQ2)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR2, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR2, One, IQR)
                Store (PRQ2, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR2)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ2)
            }
        }
        Device (LNKD)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x0F)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ3, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ3, 0x80, PRQ3)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR3, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR3, One, IQR)
                Store (PRQ3, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR3)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ3)
            }
        }
        Device (LNKE)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x10)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ4, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ4, 0x80, PRQ4)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR4, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR4, One, IQR)
                Store (PRQ4, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR4)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ4)
            }
        }
        Device (LNKF)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x11)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ5, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ5, 0x80, PRQ5)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR5, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR5, One, IQR)
                Store (PRQ5, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR5)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ5)
            }
        }
        Device (LNKG)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x12)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ6, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ6, 0x80, PRQ6)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR6, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR6, One, IQR)
                Store (PRQ6, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR6)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ6)
            }
        }
        Device (LNKH)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x13)
            Name (_PRS, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {3,4,5,6,7,9,10,11,12,15}
            })
            Method (_STA, 0, NotSerialized)
            {
                Store (0x0B, Local0)
                If (And (0x80, PRQ7, Local1))
                {
                    Store (0x09, Local0)
                }
                Return (Local0)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PRQ7, 0x80, PRQ7)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PRR7, ResourceTemplate ()
                {
                    IRQ (Level, ActiveLow, Shared, )
                        {4}
                })
                CreateWordField (PRR7, One, IQR)
                Store (PRQ7, Local0)
                If (LGreaterEqual (Local0, 0x80))
                {
                    Store (Zero, IQR)
                }
                Else
                {
                    ShiftLeft (One, Local0, IQR)
                }
                Return (PRR7)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IQR)
                FindSetRightBit (IQR, Local0)
                Decrement (Local0)
                Store (Local0, PRQ7)
            }
        }
    }
    Scope (_SB)
    {
        Device (HPET)
        {
            Name (_HID, EisaId ("PNP0103"))
            Method (_CRS, 0, NotSerialized)
            {
                Name (HBAB, ResourceTemplate ()
                {
                    Memory32Fixed (ReadOnly,
                        0xFED00000,         // Address Base
                        0x00000400,         // Address Length
                        )
                })
                Return (HBAB)
            }
        }
    }
    Scope (\)
    {
        OperationRegion (WENX, SystemIO, 0x0C0A, 0x06)
        Field (WENX, ByteAcc, NoLock, Preserve)
        {
            WEN1,   8, 
            WEN2,   8, 
            WEN3,   8, 
            WEN4,   8, 
            WEN5,   8, 
            WEN6,   8
        }
        OperationRegion (WSTX, SystemIO, 0x0C00, 0x0A)
        Field (WSTX, ByteAcc, NoLock, Preserve)
        {
            WST0,   8, 
            PMEJ,   8, 
            PENA,   8, 
            PENJ,   8, 
            WST1,   8, 
            WST2,   8, 
            WST3,   8, 
            WST4,   8, 
            WST5,   8, 
            WST6,   8
        }
        OperationRegion (SGPX, SystemIO, 0x0C4B, 0x06)
        Field (SGPX, ByteAcc, NoLock, Preserve)
        {
            SGP1,   8, 
            SGP2,   8, 
            SGP3,   8, 
            SGP4,   8, 
            SGP5,   8, 
            SGP6,   8
        }
        OperationRegion (LEDX, SystemIO, 0x0C5D, 0x02)
        Field (LEDX, ByteAcc, NoLock, Preserve)
        {
            LED1,   8, 
            LED2,   8
        }
        Method (PSKM, 1, NotSerialized)
        {
            If (Or (LEqual (Arg0, 0x03), LEqual (Arg0, One)))
            {
                Store (0x55, SIOI)
                Store (0x07, SIOI)
                Store (0x07, SIOD)
                Store (0xF0, SIOI)
                Store (SIOD, Local0)
                Or (Local0, 0x60, SIOD)
                Store (0xAA, SIOI)
                Store (WST1, Local0)
                And (Local0, 0x18, WST1)
                Store (GSTS, Local0)
                And (Local0, One, GSTS)
                Store (WEN1, Local0)
                Or (Local0, 0x18, WEN1)
            }
        }
        Method (GPKM, 0, NotSerialized)
        {
            Store (WEN1, Local0)
            And (Local0, 0xE7, WEN1)
            Store (WST1, Local0)
            And (Local0, 0x18, WST1)
            Store (GSTS, Local0)
            And (Local0, One, GSTS)
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        OperationRegion (NSIO, SystemIO, 0x2E, 0x02)
        Field (NSIO, ByteAcc, NoLock, Preserve)
        {
            INDX,   8, 
            DATA,   8
        }
        IndexField (INDX, DATA, ByteAcc, NoLock, Preserve)
        {
            Offset (0x02), 
            CFG,    8, 
            Offset (0x07), 
            LDN,    8, 
            Offset (0x20), 
            SIID,   8, 
            Offset (0x30), 
            ACTR,   8, 
            Offset (0x60), 
            IOAH,   8, 
            IOAL,   8, 
            Offset (0x70), 
            INTR,   8, 
            Offset (0x74), 
            DMCH,   8, 
            Offset (0xF0), 
            OPT1,   8, 
            OPT2,   8, 
            OPT3,   8
        }
        OperationRegion (COM, PCI_Config, 0x80, One)
        Field (COM, ByteAcc, NoLock, Preserve)
        {
            NSCA,   3, 
                ,   1, 
            NSCB,   3, 
            Offset (0x01)
        }
        OperationRegion (FDPA, PCI_Config, 0x81, One)
        Field (FDPA, ByteAcc, NoLock, Preserve)
        {
            LPTO,   2, 
                ,   2, 
            FDDC,   1, 
            Offset (0x01)
        }
        Mutex (MTX, 0x01)
        Method (SIOD, 1, NotSerialized)
        {
            CSIO (0x55)
            Store (Arg0, LDN)
            CSIO (0xAA)
        }
        Method (CSIO, 1, NotSerialized)
        {
            Store (Arg0, INDX)
        }
        Device (FDC)
        {
            Name (_HID, EisaId ("PNP0700"))
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Acquire (MTX, 0xFFFF)
                SIOD (Zero)
                If (GCFD ())
                {
                    CSIO (0x55)
                    If (ACTR)
                    {
                        CSIO (0xAA)
                        Store (0x0F, RET)
                    }
                    Else
                    {
                        CSIO (0xAA)
                        Store (0x0D, RET)
                    }
                }
                Else
                {
                    CSIO (0xAA)
                    Store (Zero, RET)
                }
                Release (MTX)
                Return (RET)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Acquire (MTX, 0xFFFF)
                SIOD (Zero)
                CSIO (0x55)
                Store (Zero, INTR)
                Store (Zero, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (FDB0, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x03F0,             // Range Minimum
                        0x03F0,             // Range Maximum
                        0x08,               // Alignment
                        0x06,               // Length
                        _Y04)
                    IO (Decode16,
                        0x03F7,             // Range Minimum
                        0x03F7,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        _Y05)
                    IRQNoFlags (_Y06)
                        {6}
                    DMA (Compatibility, NotBusMaster, Transfer8, _Y07)
                        {2}
                })
                CreateWordField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y04._MIN, IOL0)
                CreateByteField (FDB0, 0x03, IOH0)
                CreateWordField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y04._MAX, IOL1)
                CreateByteField (FDB0, 0x05, IOH1)
                CreateWordField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y05._MIN, I2L0)
                CreateByteField (FDB0, 0x0B, I2H0)
                CreateWordField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y05._MAX, I2L1)
                CreateByteField (FDB0, 0x0D, I2H1)
                CreateWordField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y06._INT, IQR)
                CreateByteField (FDB0, \_SB.PCI0.ISA.FDC._CRS._Y07._DMA, DAM)
                Acquire (MTX, 0xFFFF)
                SIOD (Zero)
                CSIO (0x55)
                Store (IOAH, IOH0)
                Store (IOAH, IOH1)
                Store (IOAL, IOL0)
                Store (IOAL, IOL1)
                Store (IOAH, I2H0)
                Store (IOAH, I2H1)
                Add (IOAL, 0x07, I2L0)
                Add (IOAL, 0x07, I2L1)
                ShiftLeft (One, INTR, IQR)
                ShiftLeft (One, DMCH, DAM)
                CSIO (0xAA)
                Release (MTX)
                Return (FDB0)
            }
            Method (_PRS, 0, NotSerialized)
            {
                Name (FDB1, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F0,             // Range Minimum
                            0x03F0,             // Range Maximum
                            0x08,               // Alignment
                            0x06,               // Length
                            )
                        IO (Decode16,
                            0x03F7,             // Range Minimum
                            0x03F7,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {6}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {2}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F0,             // Range Minimum
                            0x03F0,             // Range Maximum
                            0x08,               // Alignment
                            0x06,               // Length
                            )
                        IO (Decode16,
                            0x03F7,             // Range Minimum
                            0x03F7,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {1,2,3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0370,             // Range Minimum
                            0x0370,             // Range Maximum
                            0x08,               // Alignment
                            0x06,               // Length
                            )
                        IO (Decode16,
                            0x0377,             // Range Minimum
                            0x0377,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {1,2,3}
                    }
                    EndDependentFn ()
                })
                Return (FDB1)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateByteField (Arg0, 0x02, IOLO)
                CreateByteField (Arg0, 0x03, IOHI)
                CreateWordField (Arg0, 0x11, IQR)
                CreateByteField (Arg0, 0x14, DAM)
                Acquire (MTX, 0xFFFF)
                SIOD (Zero)
                CSIO (0x55)
                Store (IOLO, IOAL)
                Store (IOHI, IOAH)
                CSIO (0xAA)
                If (LEqual (IOLO, 0x70))
                {
                    Store (One, FDDC)
                }
                If (LEqual (IOLO, 0xF0))
                {
                    Store (Zero, FDDC)
                }
                CSIO (0x55)
                FindSetRightBit (IQR, Local0)
                Subtract (Local0, One, INTR)
                FindSetRightBit (DAM, Local0)
                Subtract (Local0, One, DMCH)
                Store (One, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
        }
        Device (KBD)
        {
            Name (_HID, EisaId ("PNP0303"))
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Store (Zero, RET)
                If (GCKB ())
                {
                    Store (0x0F, RET)
                }
                Return (RET)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (KBDB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IRQNoFlags ()
                        {1}
                })
                Return (KBDB)
            }
        }
        Device (MOU)
        {
            Name (_HID, EisaId ("PNP0F13"))
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Store (Zero, RET)
                If (GCON ())
                {
                    If (GCMS ())
                    {
                        Store (0x0F, RET)
                    }
                }
                Return (RET)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (MOUB, ResourceTemplate ()
                {
                    IRQNoFlags ()
                        {12}
                })
                Name (MOKB, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IRQNoFlags ()
                        {12}
                })
                If (GCKB ())
                {
                    Return (MOUB)
                }
                Else
                {
                    Return (MOKB)
                }
            }
        }
        Device (PRT)
        {
            Name (_HID, EisaId ("PNP0401"))
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Acquire (MTX, 0xFFFF)
                SIOD (0x03)
                If (GCPP ())
                {
                    CSIO (0x55)
                    If (ACTR)
                    {
                        CSIO (0xAA)
                        Store (0x0F, RET)
                    }
                    Else
                    {
                        CSIO (0xAA)
                        Store (0x0D, RET)
                    }
                }
                Else
                {
                    CSIO (0xAA)
                    Store (Zero, RET)
                }
                Release (MTX)
                Return (RET)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Acquire (MTX, 0xFFFF)
                SIOD (0x03)
                CSIO (0x55)
                Store (Zero, INTR)
                Store (0x04, DMCH)
                Store (Zero, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (PTB0, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0378,             // Range Minimum
                        0x0378,             // Range Maximum
                        0x08,               // Alignment
                        0x08,               // Length
                        _Y08)
                    IO (Decode16,
                        0x0778,             // Range Minimum
                        0x0778,             // Range Maximum
                        0x08,               // Alignment
                        0x08,               // Length
                        _Y09)
                    IRQNoFlags (_Y0A)
                        {7}
                    DMA (Compatibility, NotBusMaster, Transfer8, _Y0B)
                        {}
                })
                CreateWordField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y08._MIN, IOL0)
                CreateByteField (PTB0, 0x03, IOH0)
                CreateWordField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y08._MAX, IOL1)
                CreateByteField (PTB0, 0x05, IOH1)
                CreateByteField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y08._ALN, LALN)
                CreateByteField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y08._LEN, LLEN)
                CreateWordField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y09._MIN, I2L0)
                CreateByteField (PTB0, 0x0B, I2H0)
                CreateWordField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y09._MAX, I2L1)
                CreateByteField (PTB0, 0x0D, I2H1)
                CreateByteField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y09._ALN, HALN)
                CreateByteField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y09._LEN, HLEN)
                CreateWordField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y0A._INT, IQR)
                CreateByteField (PTB0, \_SB.PCI0.ISA.PRT._CRS._Y0B._DMA, DAM)
                Acquire (MTX, 0xFFFF)
                SIOD (0x03)
                CSIO (0x55)
                Store (IOAH, IOH0)
                Store (IOAH, IOH1)
                Store (IOAL, IOL0)
                Store (IOAL, IOL1)
                Add (IOAH, 0x04, I2H0)
                Add (IOAH, 0x04, I2H1)
                Store (IOAL, I2L0)
                Store (IOAL, I2L1)
                ShiftLeft (One, INTR, IQR)
                ShiftLeft (One, DMCH, DAM)
                If (LEqual (IOL0, 0xBC))
                {
                    Store (0x04, LALN)
                    Store (0x04, LLEN)
                    Store (0x04, HALN)
                    Store (0x04, HLEN)
                }
                If (LEqual (DMCH, 0x04))
                {
                    Store (Zero, DAM)
                }
                If (LEqual (INTR, Zero))
                {
                    Store (Zero, IQR)
                }
                CSIO (0xAA)
                Release (MTX)
                Return (PTB0)
            }
            Method (_PRS, 0, NotSerialized)
            {
                Name (PTB1, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {7}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {5}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {1,2,3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3,4,5,6,7,12}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {1,2,3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0378,             // Range Minimum
                            0x0378,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0778,             // Range Minimum
                            0x0778,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x0278,             // Range Minimum
                            0x0278,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IO (Decode16,
                            0x0678,             // Range Minimum
                            0x0678,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03BC,             // Range Minimum
                            0x03BC,             // Range Maximum
                            0x04,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x07BC,             // Range Minimum
                            0x07BC,             // Range Maximum
                            0x04,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03BC,             // Range Minimum
                            0x03BC,             // Range Maximum
                            0x04,               // Alignment
                            0x04,               // Length
                            )
                        IO (Decode16,
                            0x07BC,             // Range Minimum
                            0x07BC,             // Range Maximum
                            0x04,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {7}
                        DMA (Compatibility, NotBusMaster, Transfer8, )
                            {}
                    }
                    EndDependentFn ()
                })
                Return (PTB1)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateByteField (Arg0, 0x02, IOLO)
                CreateByteField (Arg0, 0x03, IOHI)
                CreateWordField (Arg0, 0x11, IQR)
                CreateByteField (Arg0, 0x14, DAM)
                Acquire (MTX, 0xFFFF)
                SIOD (0x03)
                CSIO (0x55)
                Store (IOLO, IOAL)
                Store (IOHI, IOAH)
                If (LEqual (IOLO, 0xBC))
                {
                    Store (0x02, LPTO)
                }
                If (LEqual (IOLO, 0x78))
                {
                    If (LEqual (IOHI, 0x02))
                    {
                        Store (One, LPTO)
                    }
                    If (LEqual (IOHI, 0x03))
                    {
                        Store (Zero, LPTO)
                    }
                }
                If (LEqual (IQR, Zero))
                {
                    Store (Zero, INTR)
                }
                Else
                {
                    FindSetRightBit (IQR, Local0)
                    Subtract (Local0, One, INTR)
                }
                If (LEqual (DAM, Zero))
                {
                    Store (0x04, DMCH)
                }
                Else
                {
                    FindSetRightBit (DAM, Local0)
                    Subtract (Local0, One, DMCH)
                }
                Store (One, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
        }
        Device (COMA)
        {
            Name (_HID, EisaId ("PNP0501"))
            Name (_UID, One)
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Acquire (MTX, 0xFFFF)
                SIOD (0x04)
                If (GCS1 ())
                {
                    CSIO (0x55)
                    If (ACTR)
                    {
                        CSIO (0xAA)
                        Store (0x0F, RET)
                    }
                    Else
                    {
                        CSIO (0xAA)
                        Store (0x0D, RET)
                    }
                }
                Else
                {
                    CSIO (0xAA)
                    Store (Zero, RET)
                }
                Release (MTX)
                Return (RET)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Acquire (MTX, 0xFFFF)
                SIOD (0x04)
                CSIO (0x55)
                Store (Zero, INTR)
                Store (Zero, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (CMA0, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x03F8,             // Range Minimum
                        0x03F8,             // Range Maximum
                        0x08,               // Alignment
                        0x08,               // Length
                        _Y0C)
                    IRQNoFlags (_Y0D)
                        {4}
                })
                CreateWordField (CMA0, \_SB.PCI0.ISA.COMA._CRS._Y0C._MIN, IOL0)
                CreateByteField (CMA0, 0x03, IOH0)
                CreateWordField (CMA0, \_SB.PCI0.ISA.COMA._CRS._Y0C._MAX, IOL1)
                CreateByteField (CMA0, 0x05, IOH1)
                CreateWordField (CMA0, \_SB.PCI0.ISA.COMA._CRS._Y0D._INT, IQR)
                Acquire (MTX, 0xFFFF)
                SIOD (0x04)
                CSIO (0x55)
                Store (IOAL, IOL0)
                Store (IOAL, IOL1)
                Store (IOAH, IOH0)
                Store (IOAH, IOH1)
                ShiftLeft (One, INTR, IQR)
                CSIO (0xAA)
                Release (MTX)
                Return (CMA0)
            }
            Method (_PRS, 0, NotSerialized)
            {
                Name (CMA1, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {4}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {4}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3}
                    }
                    EndDependentFn ()
                })
                Return (CMA1)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateByteField (Arg0, 0x02, IOLO)
                CreateByteField (Arg0, 0x03, IOHI)
                CreateWordField (Arg0, 0x09, IQR)
                Acquire (MTX, 0xFFFF)
                SIOD (0x04)
                CSIO (0x55)
                Store (IOLO, IOAL)
                Store (IOHI, IOAH)
                FindSetRightBit (IQR, Local0)
                Subtract (Local0, One, INTR)
                If (LEqual (IOHI, 0x03))
                {
                    If (LEqual (IOLO, 0xF8))
                    {
                        Store (Zero, NSCA)
                    }
                    If (LEqual (IOLO, 0xE8))
                    {
                        Store (0x07, NSCA)
                    }
                }
                If (LEqual (IOHI, 0x02))
                {
                    If (LEqual (IOLO, 0xF8))
                    {
                        Store (One, NSCA)
                    }
                    If (LEqual (IOLO, 0xE8))
                    {
                        Store (0x05, NSCA)
                    }
                }
                Store (One, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
        }
        Device (COMB)
        {
            Name (_HID, EisaId ("PNP0501"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                Name (RET, Zero)
                Acquire (MTX, 0xFFFF)
                SIOD (0x05)
                If (GCS2 ())
                {
                    CSIO (0x55)
                    If (ACTR)
                    {
                        CSIO (0xAA)
                        Store (0x0F, RET)
                    }
                    Else
                    {
                        CSIO (0xAA)
                        Store (0x0D, RET)
                    }
                }
                Else
                {
                    CSIO (0xAA)
                    Store (Zero, RET)
                }
                Release (MTX)
                Return (RET)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Acquire (MTX, 0xFFFF)
                SIOD (0x05)
                CSIO (0x55)
                Store (Zero, INTR)
                Store (OPT1, Local0)
                Or (Local0, 0x20, Local0)
                Store (Local0, OPT1)
                Store (Zero, ACTR)
                CSIO (0xAA)
                Release (MTX)
            }
            Method (_CRS, 0, NotSerialized)
            {
                Name (CMB0, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x03F8,             // Range Minimum
                        0x03F8,             // Range Maximum
                        0x08,               // Alignment
                        0x08,               // Length
                        _Y0E)
                    IRQNoFlags (_Y0F)
                        {4}
                })
                CreateWordField (CMB0, \_SB.PCI0.ISA.COMB._CRS._Y0E._MIN, IOL0)
                CreateByteField (CMB0, 0x03, IOH0)
                CreateWordField (CMB0, \_SB.PCI0.ISA.COMB._CRS._Y0E._MAX, IOL1)
                CreateByteField (CMB0, 0x05, IOH1)
                CreateWordField (CMB0, \_SB.PCI0.ISA.COMB._CRS._Y0F._INT, IQR)
                Acquire (MTX, 0xFFFF)
                SIOD (0x05)
                CSIO (0x55)
                Store (IOAL, IOL0)
                Store (IOAL, IOL1)
                Store (IOAH, IOH0)
                Store (IOAH, IOH1)
                ShiftLeft (One, INTR, IQR)
                CSIO (0xAA)
                Release (MTX)
                Return (CMB0)
            }
            Method (_PRS, 0, NotSerialized)
            {
                Name (CMB1, ResourceTemplate ()
                {
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {3}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {4}
                    }
                    StartDependentFnNoPri ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            )
                        IRQNoFlags ()
                            {4}
                    }
                    EndDependentFn ()
                })
                Return (CMB1)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateByteField (Arg0, 0x02, IOLO)
                CreateByteField (Arg0, 0x03, IOHI)
                CreateWordField (Arg0, 0x09, IQR)
                Acquire (MTX, 0xFFFF)
                SIOD (0x05)
                CSIO (0x55)
                Store (IOLO, IOAL)
                Store (IOHI, IOAH)
                FindSetRightBit (IQR, Local0)
                Subtract (Local0, One, INTR)
                If (LEqual (IOHI, 0x03))
                {
                    If (LEqual (IOLO, 0xF8))
                    {
                        Store (Zero, NSCB)
                    }
                    If (LEqual (IOLO, 0xE8))
                    {
                        Store (0x07, NSCB)
                    }
                }
                If (LEqual (IOHI, 0x02))
                {
                    If (LEqual (IOLO, 0xF8))
                    {
                        Store (One, NSCB)
                    }
                    If (LEqual (IOLO, 0xE8))
                    {
                        Store (0x05, NSCB)
                    }
                }
                Store (One, ACTR)
                Store (OPT1, Local0)
                And (Local0, 0xDF, Local0)
                Store (Local0, OPT1)
                CSIO (0xAA)
                Release (MTX)
            }
        }
    }
    Scope (_SB.PCI0.ISA)
    {
        Device (TPM)
        {
            Method (_HID, 0, NotSerialized)
            {
                If (GTPM ())
                {
                    Return (0x0435CF4D)
                }
                Else
                {
                    Return (0x0012AF4D)
                }
            }
            Name (_CID, EisaId ("PNP0C31"))
            Method (_STA, 0, NotSerialized)
            {
                If (GCTP ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Method (_CRS, 0, NotSerialized)
            {
                If (GCTP ())
                {
                    Return (ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0xFED40000,         // Address Base
                            0x00005000,         // Address Length
                            )
                        IO (Decode16,
                            0x0CB0,             // Range Minimum
                            0x0CB0,             // Range Maximum
                            0x08,               // Alignment
                            0x10,               // Length
                            )
                    })
                }
                Else
                {
                    Return (Buffer (One) {Zero})
                }
            }
            Method (_DSM, 4, NotSerialized)
            {
                If (LEqual (ToBuffer (Arg0), Buffer (0x10)
                        {
                            /* 0000 */   0xA6, 0xFA, 0xDD, 0x3D, 0x1B, 0x36, 0xB4, 0x4E,
                            /* 0008 */   0xA4, 0x24, 0x8D, 0x10, 0x08, 0x9D, 0x16, 0x53
                        }))
                {
                    Name (_T_0, Zero)
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Return (Buffer (One)
                        {
                             0x3F
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_0, One))
                        {
                            Return ("1.0")
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x02))
                            {
                                Store (ToInteger (Arg3), Local0)
                                And (Local0, 0x0F, Local0)
                                CMWR (0x7E, Local0)
                                Return (Zero)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x03))
                                {
                                    Store (CMRD (0x7E), Local0)
                                    And (Local0, 0x0F, Local0)
                                    Return (PPR2 (Local0))
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x04))
                                    {
                                        Return (0x02)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x05))
                                        {
                                            Store (CMRD (0x7E), Local0)
                                            ShiftRight (Local0, 0x04, Local0)
                                            Store (CMRD (0x7F), Local1)
                                            And (Local1, 0x7F, Local1)
                                            Return (PPR3 (Local0, Local1))
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x06))
                                            {
                                                Name (_T_1, "")
                                                Store (ToString (Arg3, Ones), _T_1)
                                                If (LEqual (_T_1, "en"))
                                                {
                                                    Return (Zero)
                                                }
                                                Else
                                                {
                                                    Return (One)
                                                }
                                            }
                                            Else
                                            {
                                                Return (Buffer (One)
                                                {
                                                     0x00
                                                })
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                If (LEqual (ToBuffer (Arg0), Buffer (0x10)
                        {
                            /* 0000 */   0xED, 0x54, 0x60, 0x37, 0x13, 0xCC, 0x75, 0x46,
                            /* 0008 */   0x90, 0x1C, 0x47, 0x56, 0xD7, 0xF2, 0xD4, 0x5D
                        }))
                {
                    Name (_T_2, Zero)
                    Store (ToInteger (Arg2), _T_2)
                    If (LEqual (_T_2, Zero))
                    {
                        Return (Buffer (One)
                        {
                             0x01
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_2, One))
                        {
                            Store (SMI (0xBC, And (ToInteger (Arg3), One)), Local1)
                            Return (ToInteger (Local1))
                        }
                    }
                }
                Return (Buffer (One)
                {
                     0x00
                })
            }
            Method (PPR2, 1, NotSerialized)
            {
                Name (_T_0, Zero)
                Store (ToInteger (Arg0), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Package (0x02)
                    {
                        Zero, 
                        Zero
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Return (Package (0x02)
                        {
                            Zero, 
                            One
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x02))
                        {
                            Return (Package (0x02)
                            {
                                Zero, 
                                0x02
                            })
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                Return (Package (0x02)
                                {
                                    Zero, 
                                    0x03
                                })
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x04))
                                {
                                    Return (Package (0x02)
                                    {
                                        Zero, 
                                        0x04
                                    })
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x05))
                                    {
                                        Return (Package (0x02)
                                        {
                                            Zero, 
                                            0x05
                                        })
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x06))
                                        {
                                            Return (Package (0x02)
                                            {
                                                Zero, 
                                                0x06
                                            })
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x07))
                                            {
                                                Return (Package (0x02)
                                                {
                                                    Zero, 
                                                    0x07
                                                })
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x08))
                                                {
                                                    Return (Package (0x02)
                                                    {
                                                        Zero, 
                                                        0x08
                                                    })
                                                }
                                                Else
                                                {
                                                    If (LEqual (_T_0, 0x09))
                                                    {
                                                        Return (Package (0x02)
                                                        {
                                                            Zero, 
                                                            0x09
                                                        })
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (_T_0, 0x0A))
                                                        {
                                                            Return (Package (0x02)
                                                            {
                                                                Zero, 
                                                                0x0A
                                                            })
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (_T_0, 0x0B))
                                                            {
                                                                Return (Package (0x02)
                                                                {
                                                                    Zero, 
                                                                    0x0B
                                                                })
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (_T_0, 0x0C))
                                                                {
                                                                    Return (Package (0x02)
                                                                    {
                                                                        Zero, 
                                                                        0x0C
                                                                    })
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (_T_0, 0x0D))
                                                                    {
                                                                        Return (Package (0x02)
                                                                        {
                                                                            Zero, 
                                                                            0x0D
                                                                        })
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LEqual (_T_0, 0x0E))
                                                                        {
                                                                            Return (Package (0x02)
                                                                            {
                                                                                Zero, 
                                                                                0x0E
                                                                            })
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Return (Package (0x02)
                {
                    One, 
                    Zero
                })
            }
            Method (PPR3, 2, NotSerialized)
            {
                If (LEqual (Arg1, Zero))
                {
                    Name (_T_0, Zero)
                    Store (ToInteger (Arg0), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Return (Package (0x03)
                        {
                            Zero, 
                            Zero, 
                            Zero
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_0, One))
                        {
                            Return (Package (0x03)
                            {
                                Zero, 
                                One, 
                                Zero
                            })
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x02))
                            {
                                Return (Package (0x03)
                                {
                                    Zero, 
                                    0x02, 
                                    Zero
                                })
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x03))
                                {
                                    Return (Package (0x03)
                                    {
                                        Zero, 
                                        0x03, 
                                        Zero
                                    })
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x04))
                                    {
                                        Return (Package (0x03)
                                        {
                                            Zero, 
                                            0x04, 
                                            Zero
                                        })
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x05))
                                        {
                                            Return (Package (0x03)
                                            {
                                                Zero, 
                                                0x05, 
                                                Zero
                                            })
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x06))
                                            {
                                                Return (Package (0x03)
                                                {
                                                    Zero, 
                                                    0x06, 
                                                    Zero
                                                })
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x07))
                                                {
                                                    Return (Package (0x03)
                                                    {
                                                        Zero, 
                                                        0x07, 
                                                        Zero
                                                    })
                                                }
                                                Else
                                                {
                                                    If (LEqual (_T_0, 0x08))
                                                    {
                                                        Return (Package (0x03)
                                                        {
                                                            Zero, 
                                                            0x08, 
                                                            Zero
                                                        })
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (_T_0, 0x09))
                                                        {
                                                            Return (Package (0x03)
                                                            {
                                                                Zero, 
                                                                0x09, 
                                                                Zero
                                                            })
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (_T_0, 0x0A))
                                                            {
                                                                Return (Package (0x03)
                                                                {
                                                                    Zero, 
                                                                    0x0A, 
                                                                    Zero
                                                                })
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (_T_0, 0x0B))
                                                                {
                                                                    Return (Package (0x03)
                                                                    {
                                                                        Zero, 
                                                                        0x0B, 
                                                                        Zero
                                                                    })
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (_T_0, 0x0C))
                                                                    {
                                                                        Return (Package (0x03)
                                                                        {
                                                                            Zero, 
                                                                            0x0C, 
                                                                            Zero
                                                                        })
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LEqual (_T_0, 0x0D))
                                                                        {
                                                                            Return (Package (0x03)
                                                                            {
                                                                                Zero, 
                                                                                0x0D, 
                                                                                Zero
                                                                            })
                                                                        }
                                                                        Else
                                                                        {
                                                                            If (LEqual (_T_0, 0x0E))
                                                                            {
                                                                                Return (Package (0x03)
                                                                                {
                                                                                    Zero, 
                                                                                    0x0E, 
                                                                                    Zero
                                                                                })
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    Return (Package (0x03)
                    {
                        One, 
                        Zero, 
                        Zero
                    })
                }
                Else
                {
                    Name (_T_1, Zero)
                    Store (ToInteger (Arg0), _T_1)
                    If (LEqual (_T_1, Zero))
                    {
                        Return (Package (0x03)
                        {
                            Zero, 
                            Zero, 
                            0xFFFFFFF0
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_1, One))
                        {
                            Return (Package (0x03)
                            {
                                Zero, 
                                One, 
                                0xFFFFFFF0
                            })
                        }
                        Else
                        {
                            If (LEqual (_T_1, 0x02))
                            {
                                Return (Package (0x03)
                                {
                                    Zero, 
                                    0x02, 
                                    0xFFFFFFF0
                                })
                            }
                            Else
                            {
                                If (LEqual (_T_1, 0x03))
                                {
                                    Return (Package (0x03)
                                    {
                                        Zero, 
                                        0x03, 
                                        0xFFFFFFF0
                                    })
                                }
                                Else
                                {
                                    If (LEqual (_T_1, 0x04))
                                    {
                                        Return (Package (0x03)
                                        {
                                            Zero, 
                                            0x04, 
                                            0xFFFFFFF0
                                        })
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_1, 0x05))
                                        {
                                            Return (Package (0x03)
                                            {
                                                Zero, 
                                                0x05, 
                                                0xFFFFFFF0
                                            })
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_1, 0x06))
                                            {
                                                Return (Package (0x03)
                                                {
                                                    Zero, 
                                                    0x06, 
                                                    0xFFFFFFF0
                                                })
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_1, 0x07))
                                                {
                                                    Return (Package (0x03)
                                                    {
                                                        Zero, 
                                                        0x07, 
                                                        0xFFFFFFF0
                                                    })
                                                }
                                                Else
                                                {
                                                    If (LEqual (_T_1, 0x08))
                                                    {
                                                        Return (Package (0x03)
                                                        {
                                                            Zero, 
                                                            0x08, 
                                                            0xFFFFFFF0
                                                        })
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (_T_1, 0x09))
                                                        {
                                                            Return (Package (0x03)
                                                            {
                                                                Zero, 
                                                                0x09, 
                                                                0xFFFFFFF0
                                                            })
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (_T_1, 0x0A))
                                                            {
                                                                Return (Package (0x03)
                                                                {
                                                                    Zero, 
                                                                    0x0A, 
                                                                    0xFFFFFFF0
                                                                })
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (_T_1, 0x0B))
                                                                {
                                                                    Return (Package (0x03)
                                                                    {
                                                                        Zero, 
                                                                        0x0B, 
                                                                        0xFFFFFFF0
                                                                    })
                                                                }
                                                                Else
                                                                {
                                                                    If (LEqual (_T_1, 0x0C))
                                                                    {
                                                                        Return (Package (0x03)
                                                                        {
                                                                            Zero, 
                                                                            0x0C, 
                                                                            0xFFFFFFF0
                                                                        })
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (LEqual (_T_1, 0x0D))
                                                                        {
                                                                            Return (Package (0x03)
                                                                            {
                                                                                Zero, 
                                                                                0x0D, 
                                                                                0xFFFFFFF0
                                                                            })
                                                                        }
                                                                        Else
                                                                        {
                                                                            If (LEqual (_T_1, 0x0E))
                                                                            {
                                                                                Return (Package (0x03)
                                                                                {
                                                                                    Zero, 
                                                                                    0x0E, 
                                                                                    0xFFFFFFF0
                                                                                })
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    Return (Package (0x03)
                    {
                        One, 
                        Zero, 
                        Zero
                    })
                }
            }
        }
    }
}
